/*  G-Cows - scripting language for creation of web sites
    Copyright (C) 2002, 2003, 2004, 2005, 2006 Andrea Sozzi

This file is part of G-Cows.

G-Cows is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

G-Cows is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; see the file COPYING.  If not, write to
the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.  */


#ifndef LIB_OPTIONS_H
#define LIB_OPTIONS_H

#include <map>
#include "common.H"

using std::string;

class Options : public std::multimap<int, std::string> {
public:
  string get_opt (int opt_id);
  virtual ~Options () {};
protected:
  virtual void usage (int status) = 0;
  virtual void version () = 0;
  void set_opt (int opt_id, string value);
  void add_opt (int opt_id, string value) 
  {
    insert (make_pair (opt_id, value)); 
  }
  string program_name;
};

#endif // ! LIB_OPTIONS_H
