/*  G-Cows - scripting language for creation of web sites
    Copyright (C) 2002, 2003, 2004, 2005, 2006 Andrea Sozzi

This file is part of G-Cows.

G-Cows is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

G-Cows is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; see the file COPYING.  If not, write to
the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.  */


#include "utils.H"
#include <cstdio>
#include <unistd.h>
#include <cmath>

using namespace std;

string 
Utils::trim (const string& src) 
{
  if (src.length () == 0)
    return src;
  unsigned int begin = src.find_first_not_of (" \t\n");
  if (begin == string::npos)
    return "";
  unsigned int end = src.find_last_not_of (" \t\n");
  return string (src, begin, end - begin + 1);
}

string 
Utils::ltrim (const string& src) 
{
  if (src.length () == 0)
    return src;
  unsigned int begin = src.find_first_not_of (" \t\n");
  if (begin == string::npos)
    return "";
  return string (src, begin, src.length () - begin + 1);
}

string 
Utils::rtrim (const string& src) 
{
  if (src.length () == 0)
    return src;
  unsigned int end = src.find_last_not_of (" \t\n");
  if (end == string::npos)
    return "";
  return string (src, 0, end + 1);
}



/*
string
Utils::itos (int integer) {
    int length = (integer==0) ? 1 : (int) (log10 (abs(integer)) 
                                           + ((integer>0)?1:2));
    char *pool = new char [length + 1];
    if (!pool) 
        Diag::inst()->error ("memory exausted");
    snprintf (pool, length + 1, "%d", integer);
    string ret_value (pool);
    delete [] pool;
    return ret_value;
}
*/
