/*  G-Cows - scripting language for creation of web sites
    Copyright (C) 2002, 2003, 2004, 2005, 2006 Andrea Sozzi

This file is part of G-Cows.

G-Cows is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

G-Cows is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; see the file COPYING.  If not, write to
the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.  */


#ifndef SRC_COWS_OPTIONS_H
#define SRC_COWS_OPTIONS_H

#include <cstdio>
#include <fstream>
#include <vector>
#include "common.H"
#include "options.H"

typedef std::vector<string> string_vector;
typedef string_vector::iterator string_iter;

/* Handle Cows options and affected variables */

class Cows_opt : public Options {
public:
    Cows_opt (int argc, char *argv[]);
    ~Cows_opt ();
    string get_next_var ();
    FILE *get_input_file () { return input_file; }
    void dump_output (const char *buffer);
    void dump_report (string in, string out, int warnings, int errors);
    enum { root_dir, define, parents, input, report, report_file, output, 
           output_abs, noext };
private:
    void usage (int status);
    void version ();
    void accessibility ();
    string program_name;
    string_vector var_init;
    FILE *input_file;
};

#endif // ! SRC_COWS_OPTIONS_H
