/*  G-Cows - scripting language for creation of web sites
    Copyright (C) 2002, 2003, 2004, 2005, 2006 Andrea Sozzi

This file is part of G-Cows.

G-Cows is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

G-Cows is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; see the file COPYING.  If not, write to
the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.  */


#include "error.H"
#include "nest.H"

using namespace std;

/* Restore the last flex start condition (see comments in nest.H)  */

int
Nested_tags::restore_condition () 
{
  if ( conditions.empty () )
    Msg::inst()->fatal 
      ("Nested_tags::restore_condition ()-internal error");
  Conditions_iter iter = conditions.end ();
  conditions.erase (--iter);
  return *(--iter);
}

void 
Nested_tags::reset_conditions () 
{
  if (conditions.size () >1) 
    {
      Msg::inst()->warning ("found unclosed cows tags");
      Conditions_iter first_to_erase = conditions.begin ();
      first_to_erase++;
      conditions.erase (first_to_erase, conditions.end ()); 
    }
}
